// Copyright (C) 2007 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include <ilu.h>
#include <stdio.h>
#include <stdlib.h>

int
main(int argc, char *argv[])
{
	ILuint x = 0, y = 0;
	ILboolean buttons[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };
	ilOpen(IL_JOYSTICK_BIT | IL_KEYBOARD_BIT);
	ILboolean loop = IL_TRUE;
	ILevent event;
	while(loop)
	{
		ilRead(IL_JOYSTICK_BIT | IL_KEYBOARD_BIT);
		if(ilEvent(IL_JOYSTICK_BIT))
		{
			ilGetEvent(IL_JOYSTICK_BIT, &event);
			switch(event.type)
			{
				case IL_EVENT_TYPE_ABS:
					switch(event.code)
					{
						case IL_EVENT_CODE_ABS_X:
							if(event.value < 100) x = -1;
							else if(event.value > 500) x = 1;
							else x = 0;
							break;
						case IL_EVENT_CODE_ABS_Y:
							if(event.value < 100) y = -1;
							else if(event.value > 500) y = 1;
							else y = 0;
							break;
						case IL_EVENT_CODE_ABS_X2:
							if(event.value < 100)
							{
								buttons[4] = 1; buttons[5] = 0;
							}
							else if(event.value > 500)
							{
							       	buttons[4] = 0; buttons[5] = 1;
							}
							else buttons[4] = buttons[5] = 0;
							break;
						case IL_EVENT_CODE_ABS_Y2:
							if(event.value < 100)
							{
								buttons[6] = 1; buttons[7] = 0;
							}
							else if(event.value > 500)
							{
							       	buttons[6] = 0; buttons[7] = 1;
							}
							else buttons[6] = buttons[7] = 0;
							break;
						default: break;
					}
				break;
				case IL_EVENT_TYPE_KEY:
					switch(event.code)
					{
						case IL_EVENT_CODE_BTN_A: buttons[0] = event.value; break;
						case IL_EVENT_CODE_BTN_B: buttons[1] = event.value; break;
						case IL_EVENT_CODE_BTN_C: buttons[2] = event.value; break;
						case IL_EVENT_CODE_BTN_D: buttons[3] = event.value; break;
					}
				break;
			}
			
			printf("(%2i, %2i) [%1i][%1i][%1i][%1i][%1i][%1i][%1i][%1i]\r",
					x, y,
					buttons[0], buttons[1], buttons[2], buttons[3],
					buttons[4], buttons[5], buttons[6], buttons[7]);
			fflush(stdout);
		}
		if(ilEvent(IL_KEYBOARD_BIT))
		{
			ilGetEvent(IL_KEYBOARD_BIT, &event);
			if(iluIsEvent(event, IL_EVENT_TYPE_KEY, IL_EVENT_CODE_KEY_ESC, 1))
				loop = IL_FALSE;
		}
	}
	ilClose(IL_JOYSTICK_BIT | IL_KEYBOARD_BIT);
	return EXIT_SUCCESS;
}
