// Copyright (C) 2007 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include <ilu.h>
#include <stdio.h>
#include <stdlib.h>

int
main(int argc, char *argv[])
{
	ILuint x = 0, y = 0, wheel = 0;
	ILboolean buttons[3] = {0, 0, 0};
	ilOpen(IL_MOUSE_BIT | IL_KEYBOARD_BIT);
	ILboolean loop = IL_TRUE;
	ILevent event;
	while(loop)
	{
		ilRead(IL_MOUSE_BIT | IL_KEYBOARD_BIT);
		if(ilEvent(IL_MOUSE_BIT))
		{
			ilGetEvent(IL_MOUSE_BIT, &event);
			switch(event.type)
			{
				case IL_EVENT_TYPE_REL:
					switch(event.code)
					{
						case IL_EVENT_CODE_REL_X: x += event.value; break;
						case IL_EVENT_CODE_REL_Y: y += event.value; break;
						case IL_EVENT_CODE_REL_WHEEL: wheel += event.value; break;
						default: break;
					}
				break;
				case IL_EVENT_TYPE_KEY:
					switch(event.code)
					{
						case IL_EVENT_CODE_BTN_LEFT: buttons[0] = event.value; break;
						case IL_EVENT_CODE_BTN_MIDDLE: buttons[1] = event.value; break;
						case IL_EVENT_CODE_BTN_RIGHT: buttons[2] = event.value; break;
					}
				break;
			}
			
			printf("(%6i, %6i) [%2i] [%1i][%1i][%1i]\r", x, y, wheel, buttons[0], buttons[1], buttons[2]);
			fflush(stdout);
		}
		if(ilEvent(IL_KEYBOARD_BIT))
		{
			ilGetEvent(IL_KEYBOARD_BIT, &event);
			if(iluIsEvent(event, IL_EVENT_TYPE_KEY, IL_EVENT_CODE_KEY_ESC, 1))
				loop = IL_FALSE;
		}
	}
	ilClose(IL_MOUSE_BIT | IL_KEYBOARD_BIT);
	return EXIT_SUCCESS;
}
