// Copyright (C) 2007 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include <il.h>
#include "joystick.h"
#include "mouse.h"
#include "keyboard.h"

void
ilOpen(ILenum cap)
{
	if((cap & IL_JOYSTICK_BIT) == IL_JOYSTICK_BIT) _ilJoystickOpen();
	if((cap & IL_MOUSE_BIT) == IL_MOUSE_BIT) _ilMouseOpen();
	if((cap & IL_KEYBOARD_BIT) == IL_KEYBOARD_BIT) _ilKeyboardOpen();
}

void
ilClose(ILenum cap)
{
	if((cap & IL_JOYSTICK_BIT) == IL_JOYSTICK_BIT) _ilJoystickClose();
	if((cap & IL_MOUSE_BIT) == IL_MOUSE_BIT) _ilMouseClose();
	if((cap & IL_KEYBOARD_BIT) == IL_KEYBOARD_BIT) _ilKeyboardClose();
}

ILboolean
ilIsOpened(ILenum cap)
{

	ILboolean ret = IL_FALSE;
	switch(cap)
	{
		case IL_JOYSTICK_BIT: ret = _ilJoystickOpened(); break;
		case IL_MOUSE_BIT: ret = _ilMouseOpened(); break;
		case IL_KEYBOARD_BIT: ret = _ilKeyboardOpened(); break;
		default: break;
	}
	return ret;
}

void
ilRead(ILenum cap)
{
	if((cap & IL_JOYSTICK_BIT) == IL_JOYSTICK_BIT) _ilJoystickRead();
	if((cap & IL_MOUSE_BIT) == IL_MOUSE_BIT) _ilMouseRead();
	if((cap & IL_KEYBOARD_BIT) == IL_KEYBOARD_BIT) _ilKeyboardRead();
}

ILboolean
ilEvent(ILenum cap)
{
	ILboolean ret = IL_FALSE;
	switch(cap)
	{
		case IL_JOYSTICK_BIT: ret = _ilJoystickEvent(); break;
		case IL_MOUSE_BIT: ret = _ilMouseEvent(); break;
		case IL_KEYBOARD_BIT: ret = _ilKeyboardEvent(); break;
		default: break;
	}
	return ret;
}

void
ilGetEvent(ILenum cap, ILevent *event)
{
	switch(cap)
	{
		case IL_JOYSTICK_BIT: _ilJoystickGetEvent(event); break;
		case IL_MOUSE_BIT: _ilMouseGetEvent(event); break;
		case IL_KEYBOARD_BIT: _ilKeyboardGetEvent(event); break;
		default: break;
	}
}
