// Copyright (C) 2007 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#ifndef _FIL_H_
#define _FIL_H_

#include <il_defs.h>

typedef enum {
	IL_JOYSTICK_BIT = 1,
	IL_MOUSE_BIT = 2,
	IL_KEYBOARD_BIT = 4,
	IL_JOYSTICK_OPENED,
	IL_JOYSTICK_EVENT_TYPE,
	IL_JOYSTICK_EVENT_CODE,
	IL_JOYSTICK_EVENT_VALUE,
	IL_MOUSE_OPENED,
	IL_MOUSE_EVENT_TYPE,
	IL_MOUSE_EVENT_CODE,
	IL_MOUSE_EVENT_VALUE,
	IL_KEYBOARD_OPENED,
	IL_KEYBOARD_EVENT_TYPE,
	IL_KEYBOARD_EVENT_CODE,
	IL_KEYBOARD_EVENT_VALUE
} ILenum;

typedef enum { IL_TRUE = 1, IL_FALSE = !IL_TRUE } ILboolean;
typedef double ILdouble;
typedef float ILfloat;
typedef int ILint;
typedef unsigned int ILuint;
typedef int ILsizei;
typedef void ILvoid;

void
ilOpen(ILenum cap);

void
ilClose(ILenum cap);

ILboolean
ilIsOpened(ILenum cap);

void
ilRead(ILenum cap);

ILboolean
ilEvent(ILenum cap);

void
ilGetEvent(ILenum cap, ILevent *event);

#endif
