// Copyright (C) 2007 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#define _GNU_SOURCE
#include <stdio.h>
#include "config.h"
#include <il.h>
#include <stdlib.h>
#include <string.h>

void
_ilConfigGet(const char *device, char **file)
{
	FILE *config;
      	config = fopen("/etc/filrc", "r");
	if(!config)
	{
		char *pathname;
		asprintf(&pathname, "%s/.filrc", getenv("HOME"));
		config = fopen(pathname, "r");
		if(!config)
		{
			fprintf(stderr, "Configuration file %s not found\n", pathname);
			exit(EXIT_FAILURE);
		}
	}
	char *variable, *value;
	ILboolean found = IL_FALSE;
	while(!found && !feof(config))
	{
		fscanf(config, "%a[a-zA-Z0-9] = %a[^\n]\n", &variable, &value);
		if(strcmp(device, variable) == 0)
		{
			found = IL_TRUE;
			*file = strdup(value);
		}
	}
	if(!found)
	{
		fprintf(stderr, "Device not configured\n");
		exit(EXIT_FAILURE);
	}
}
