// Copyright (C) 2007 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#ifndef _FIL_LINUX_
#define _FIL_LINUX_

#include <linux/input.h>

enum {
	IL_EVENT_TYPE_REL = EV_REL,
	IL_EVENT_TYPE_ABS = EV_ABS,
	IL_EVENT_TYPE_KEY = EV_KEY,

	IL_EVENT_CODE_REL_X = REL_X,
	IL_EVENT_CODE_REL_Y = REL_Y,
	IL_EVENT_CODE_REL_WHEEL = REL_WHEEL,

	IL_EVENT_CODE_ABS_X = ABS_X,
	IL_EVENT_CODE_ABS_Y = ABS_Y,
	IL_EVENT_CODE_ABS_X2 = ABS_THROTTLE,
	IL_EVENT_CODE_ABS_Y2 = ABS_RUDDER,
	
	/* mouse keys */
	IL_EVENT_CODE_BTN_LEFT = BTN_LEFT,
	IL_EVENT_CODE_BTN_MIDDLE = BTN_MIDDLE,
	IL_EVENT_CODE_BTN_RIGHT = BTN_RIGHT,

	/* joystick keys */
	IL_EVENT_CODE_BTN_A = BTN_TRIGGER,
	IL_EVENT_CODE_BTN_B = BTN_THUMB,
	IL_EVENT_CODE_BTN_C = BTN_TOP,
	IL_EVENT_CODE_BTN_D = BTN_TOP2,

	/* keyboard keys */
	IL_EVENT_CODE_KEY_ESC = KEY_ESC
};

typedef struct input_event ILevent;

#endif
