// Copyright (C) 2007 Juan Manuel Borges Caño

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include "../mouse.h"
#include "config.h"
#include <linux/input.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

static int _fd = -1;
static struct input_event _event;
static ssize_t _read;

void
_ilMouseOpen()
{
	char *file;
	_ilConfigGet("mouse", &file);
	_fd = open(file, O_RDONLY | O_NONBLOCK);
	free(file);
}

void
_ilMouseClose()
{
	close(_fd);
	_fd = -1;
}

ILboolean
_ilMouseOpened()
{
	return (_fd != -1);
}

void
_ilMouseRead()
{
	_read = read(_fd, &_event, sizeof(struct input_event));
}

ILboolean
_ilMouseEvent()
{
	return ((_read > 0) && (_event.type != EV_SYN));
}

void
_ilMouseGetEvent(ILevent *event)
{
	memcpy(event, &_event, sizeof(ILevent));
}
